function [ h1h2, H, invH ] = ...
    injectSignal (sourceMap, pixOmega, freqBins, alpha, HAlpha detSep, Gamma)

% Generates the product h1*(t,f)h2(t,f) directly for the supplied
% source map of the sky. h1(t,f),h2(t,f) are not calculated individually
%
% [ h1h2, H, invH ] = ...
%   injectSignal (sourceMap, pixOmega, freqBins, alpha, detSep, Gamma)
%
% sourceMap  Real vector. Strengths of injected point sources at each pixel
% pixOmega   Real matrix. Array of direction cosines of pixels
%            Index 1: pixel number, Index 2: axis
% freqBins   Real row vector. Position of frequency bins
% alpha      Real. Power law index of source PSD
% HAlpha     Real. H_alpha
% detSep     Real matrix. Detector separation vector at all sideral times
%            Index 1: Vector component, Index 2: sidereal time
% Gamma      Real matrix. Combination of antenna patterns for all directions
%            and sideral times. Index 1: pixel, Index 2: sidereal time
%            *** CAUTION: Gamma is NOT the full overlap reduction function ***
%
% H          Real vector. Frequency power spectrum of the source
% invH       Real vector. Inverse of frequency power spectrum of the source
% h1h2       Complex matrix. Contains h1*(f)h2(f) at every time bin
%            Index 1: time, Index 2: frequency

%
% Author: Sanjit Mitra <sanjit.mitra@ligo.org>
%


H = zeros (length(freqBins),1);
invH = zeros (length(freqBins),1);
h1h2 = complex (zeros(length(Gamma(1,:)),length(freqBins)), ...
                zeros(length(Gamma(1,:)),length(freqBins)));


velLight = 2.99792458e10;


% Using a power law source PSD

H = HAlpha*((freqBins'/100.0) .^ alpha);
invH = 1.0 ./ H;

% Use true astrophysical PSD generated by Tania?


% Inject point sources if sourceMap is supplied
if (length(sourceMap) == length(pixOmega(1,:)))
   for iPixel = 1:length(sourceMap)
       h1h2 = h1h2 + sourceMap(iPixel)*((H * Gamma(iPixel,:))' .* ...
           exp(2.0*pi*i*((detSep'*pixOmega(:,iPixel))*freqBins)/velLight));
   end
else
   fprintf ('\n*** Not injecting source map ***\n');
end

return
